# Version: 20190412.0
# See https://github.com/RehanSaeed/EditorConfig for updates to this file.
# See http://EditorConfig.org for more information about .editorconfig files.
#

#################
# Common Settings
#################

# This file is the top-most EditorConfig file
root = true

# All Files
[*]
charset = utf-8
end_of_line = crlf
indent_style = space
indent_size = 4
insert_final_newline = false
trim_trailing_whitespace = true

#########################
# File Extension Settings
#########################

# Visual Studio Solution Files
[*.sln]
indent_style = tab

# Visual Studio XML Project Files
[*.{csproj,vbproj,vcxproj,vcxproj.filters,proj,projitems,shproj}]
indent_size = 2

# Various XML Configuration Files
[*.{xml,config,props,targets,nuspec,resx,ruleset,vsixmanifest,vsct}]
indent_size = 2

# JSON Files
[*.{json,json5}]
indent_size = 2

# YAML Files
[*.{yml,yaml}]
indent_size = 2

# Markdown Files
[*.md]
trim_trailing_whitespace = false

# Web Files
[*.{htm,html,js,ts,tsx,css,sass,scss,less,svg,vue}]
indent_size = 2
insert_final_newline = true

# Batch Files
[*.{cmd,bat}]

# Bash Files
[*.sh]
end_of_line = lf

###########################
# .NET Language Conventions
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#language-conventions
###########################

# .NET Code Style Settings
[*.{cs,csx,cake,vb}]
# "this." and "Me." qualifiers
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#this_and_me
dotnet_style_qualification_for_field = none
dotnet_style_qualification_for_property = none
dotnet_style_qualification_for_method = none
dotnet_style_qualification_for_event = none
# Language keywords instead of framework type names for type references
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#language_keywords
dotnet_style_predefined_type_for_locals_parameters_members = true:warning
dotnet_style_predefined_type_for_member_access = true:warning
# Modifier preferences
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#normalize_modifiers
dotnet_style_require_accessibility_modifiers = always:warning
csharp_preferred_modifier_order = public,private,protected,internal,static,extern,new,virtual,abstract,sealed,override,readonly,unsafe,volatile,async
visual_basic_preferred_modifier_order = Partial,Default,Private,Protected,Public,Friend,NotOverridable,Overridable,MustOverride,Overloads,Overrides,MustInherit,NotInheritable,Static,Shared,Shadows,ReadOnly,WriteOnly,Dim,Const,WithEvents,Widening,Narrowing,Custom,Async
dotnet_style_readonly_field = true:warning
# Parentheses preferences
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#parentheses
dotnet_style_parentheses_in_arithmetic_binary_operators = always_for_clarity:warning
dotnet_style_parentheses_in_relational_binary_operators = always_for_clarity:warning
dotnet_style_parentheses_in_other_binary_operators = always_for_clarity:warning
dotnet_style_parentheses_in_other_operators = never_if_unnecessary:suggestion
# Expression-level preferences
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#expression_level
dotnet_style_object_initializer = true:warning
dotnet_style_collection_initializer = true:warning
dotnet_style_explicit_tuple_names = true:warning
dotnet_style_prefer_inferred_tuple_names = true:warning
dotnet_style_prefer_inferred_anonymous_type_member_names = true:warning
dotnet_style_prefer_auto_properties = true:warning
dotnet_style_prefer_is_null_check_over_reference_equality_method = true:warning
dotnet_style_prefer_conditional_expression_over_assignment = false:suggestion
dotnet_style_prefer_conditional_expression_over_return = false:suggestion
# Null-checking preferences
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#null_checking
dotnet_style_coalesce_expression = true:warning
dotnet_style_null_propagation = true:warning

# C# Code Style Settings
[*.{cs,csx,cake}]
# Implicit and explicit types
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#implicit-and-explicit-types
csharp_style_var_for_built_in_types = true:warning
csharp_style_var_when_type_is_apparent = true:warning
csharp_style_var_elsewhere = true:warning
# Expression-bodied members
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#expression_bodied_members
csharp_style_expression_bodied_methods = true:suggestion
csharp_style_expression_bodied_constructors = none
csharp_style_expression_bodied_operators = true:suggestion
csharp_style_expression_bodied_properties = none
csharp_style_expression_bodied_indexers = true:warning
csharp_style_expression_bodied_accessors = true:warning
# Pattern matching
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#pattern_matching
csharp_style_pattern_matching_over_is_with_cast_check = true:warning
csharp_style_pattern_matching_over_as_with_null_check = true:warning
# Inlined variable declarations
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#inlined_variable_declarations
csharp_style_inlined_variable_declaration = true:warning
# Expression-level preferences
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#expression_level_csharp
csharp_prefer_simple_default_expression = true:warning
csharp_style_deconstructed_variable_declaration = true:warning
csharp_style_pattern_local_over_anonymous_function = true:warning
# "Null" checking preferences
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#null_checking_csharp
csharp_style_throw_expression = true:warning
csharp_style_conditional_delegate_call = true:warning
# Code block preferences
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#code_block
csharp_prefer_braces = true:warning

#############################
# .NET Formatting Conventions
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#formatting-conventions
#############################

# Organize usings
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#usings
dotnet_sort_system_directives_first = true
# C# formatting settings
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#c-formatting-settings
csharp_new_line_before_open_brace = all
csharp_new_line_before_else = true
csharp_new_line_before_catch = true
csharp_new_line_before_finally = true
csharp_new_line_before_members_in_object_initializers = true
csharp_new_line_before_members_in_anonymous_types = true
csharp_new_line_between_query_expression_clauses = true
# Indentation options
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#indent
csharp_indent_case_contents = true
csharp_indent_switch_labels = true
csharp_indent_labels = no_change
# Spacing options
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#spacing
csharp_space_after_cast = false
csharp_space_after_keywords_in_control_flow_statements = true
csharp_space_between_method_declaration_parameter_list_parentheses = false
csharp_space_between_method_call_parameter_list_parentheses = false
csharp_space_between_parentheses = expressions
csharp_space_before_colon_in_inheritance_clause = true
csharp_space_after_colon_in_inheritance_clause = true
csharp_space_around_binary_operators = before_and_after
csharp_space_between_method_declaration_empty_parameter_list_parentheses = false
csharp_space_between_method_call_name_and_opening_parenthesis = false
csharp_space_between_method_call_empty_parameter_list_parentheses = false
# Wrapping options
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-code-style-settings-reference#wrapping
csharp_preserve_single_line_statements = false
csharp_preserve_single_line_blocks = true
# More Indentation options (Undocumented)
csharp_indent_block_contents = true
csharp_indent_braces = false
# Spacing Options (Undocumented)
csharp_space_after_comma = true
csharp_space_after_dot = false
csharp_space_after_semicolon_in_for_statement = true
csharp_space_around_declaration_statements = do_not_ignore
csharp_space_before_comma = false
csharp_space_before_dot = false
csharp_space_before_semicolon_in_for_statement = false
csharp_space_before_open_square_brackets = false
csharp_space_between_empty_square_brackets = false
csharp_space_between_method_declaration_name_and_open_parenthesis = false
csharp_space_between_square_brackets = false

#########################
# .NET Naming conventions
# https://docs.microsoft.com/en-us/visualstudio/ide/editorconfig-naming-conventions
#########################

[*.{cs,csx,cake,vb}]

######################################################################
# Styles
######################################################################
# camel_case_style - Define the camelCase style
dotnet_naming_style.camel_case_style.capitalization = camel_case
# pascal_case_style - Define the Pascal_case style
dotnet_naming_style.pascal_case_style.capitalization = pascal_case
# first_upper_style - The first character must start with an upper-case character
dotnet_naming_style.first_upper_style.capitalization = first_word_upper
# prefix_interface_interface_with_i_style - Interfaces must be PascalCase and the first character of an interface must be an 'I'
dotnet_naming_style.prefix_interface_with_i_style.capitalization = pascal_case
dotnet_naming_style.prefix_interface_with_i_style.required_prefix = I
# prefix_interface_type_parameters_with_t_style - Generic Type Parameters must be PascalCase and the first character must be a 'T'
dotnet_naming_style.prefix_type_parameters_with_t_style.capitalization = pascal_case
dotnet_naming_style.prefix_type_parameters_with_t_style.required_prefix = T
# disallowed_by_design_guidelines_style - use to auto-format items that are disallowed by the design guidelines, such as publicly exposed fields
dotnet_naming_style.disallowed_style.capitalization = pascal_case
dotnet_naming_style.disallowed_style.required_prefix = ____INVALID____
dotnet_naming_style.disallowed_style.required_suffix = ____INVALID____
# SANITY_CHECK_OTHER_FIELD_TYPES_STYLE - used to identify items that the current rule set does not explicitly cover
dotnet_naming_style.missing_rule_for_field_style.capitalization  = pascal_case
dotnet_naming_style.missing_rule_for_field_style.required_prefix = ____RULES_DO_NOT_COVER_FIELD_TYPE____
dotnet_naming_style.missing_rule_for_field_style.required_suffix = ____RULES_DO_NOT_COVER_FIELD_TYPE____

######################################################################
# Symbols Groups
######################################################################

######################################################################
# NAMING CONVENTIONS FOR FIELDS ======================================
#
# Naming rules for fields are slightly more complex than other naming
# rules, therefore justifying some inline documentation / pointers.
#
# .NET Framework [Design Guidelines](https://docs.microsoft.com/en-us/dotnet/standard/design-guidelines/index)
# -- These only cover publicly-exposed fields and APIs.
# -- Thus, internal, private, and private protected fields, because
#    they are not exposed outside the containing assembly, are
#    considered OUT OF SCOPE (these rules do not apply).
# -- Publicly exposed fields are EXPLICITLY DISALLOWED, with two expections:
#    (1) public const fields and
#    (2) public static readonly fields.
#    See https://docs.microsoft.com/en-us/dotnet/standard/design-guidelines/field
# -- All publicly-exposed fields must be PascalCase.
#

# NG1. guidelines_public_constant_fields_group - public field exception, PascalCasing
#      See https://docs.microsoft.com/en-us/dotnet/standard/design-guidelines/field
dotnet_naming_symbols.guidelines_public_constant_fields_group.applicable_accessibilities = public, protected, protected_internal
dotnet_naming_symbols.guidelines_public_constant_fields_group.required_modifiers         = const
dotnet_naming_symbols.guidelines_public_constant_fields_group.applicable_kinds           = field
dotnet_naming_rule.guidelines_public_constant_fields_must_be_pascal_case_rule.symbols  = guidelines_public_constant_fields_group
dotnet_naming_rule.guidelines_public_constant_fields_must_be_pascal_case_rule.style    = pascal_case_style
dotnet_naming_rule.guidelines_public_constant_fields_must_be_pascal_case_rule.severity = warning

# NG2. guidelines_public_static_readonly_fields_group - public field exception, PascalCasing
#      See https://docs.microsoft.com/en-us/dotnet/standard/design-guidelines/field
dotnet_naming_symbols.guidelines_public_static_readonly_fields_group.applicable_accessibilities = public, protected, protected_internal
dotnet_naming_symbols.guidelines_public_static_readonly_fields_group.required_modifiers         = static, readonly
dotnet_naming_symbols.guidelines_public_static_readonly_fields_group.applicable_kinds           = field
dotnet_naming_rule.guidelines_public_static_readonly_fields_must_be_pascal_case_rule.symbols  = guidelines_public_static_readonly_fields_group
dotnet_naming_rule.guidelines_public_static_readonly_fields_must_be_pascal_case_rule.style    = pascal_case_style
dotnet_naming_rule.guidelines_public_static_readonly_fields_must_be_pascal_case_rule.severity = warning

# NG3. guidelines_other_publicly_exposed_fields_group - explicitly DISALLOWED
#      See https://docs.microsoft.com/en-us/dotnet/standard/design-guidelines/field
dotnet_naming_symbols.guidelines_other_publicly_exposed_fields_group.applicable_accessibilities = public, protected, protected_internal
dotnet_naming_symbols.guidelines_other_publicly_exposed_fields_group.applicable_kinds           = field
dotnet_naming_rule.guidelines_other_publicly_exposed_fields_disallowed_rule.symbols  = guidelines_other_publicly_exposed_fields_group
dotnet_naming_rule.guidelines_other_publicly_exposed_fields_disallowed_rule.style    = disallowed_style
dotnet_naming_rule.guidelines_other_publicly_exposed_fields_disallowed_rule.severity = error

#
# As a second-level, [StyleCop](https://github.com/DotNetAnalyzers/StyleCopAnalyzers)
# defines many additional rules.
# -- Although many StyleCop rules might apply to publicly-exposed fields,
#    the rules defined here do NOT allow publicly-exposed fields, because
#    they are explicitly disallowed by the .NET Framework Design Guidelines
#

# SC1. stylecop_constant_fields_group -- PascalCase required
#      See https://github.com/DotNetAnalyzers/StyleCopAnalyzers/blob/master/documentation/SA1303.md
dotnet_naming_symbols.stylecop_constant_fields_group.applicable_accessibilities = internal, private_protected, private, public, protected, protected_internal
dotnet_naming_symbols.stylecop_constant_fields_group.required_modifiers         = const
dotnet_naming_symbols.stylecop_constant_fields_group.applicable_kinds           = field
dotnet_naming_rule.stylecop_all_constant_fields_must_be_pascal_case_rule.symbols  = stylecop_constant_fields_group
dotnet_naming_rule.stylecop_all_constant_fields_must_be_pascal_case_rule.style    = pascal_case_style
dotnet_naming_rule.stylecop_all_constant_fields_must_be_pascal_case_rule.severity = warning

# SC2. stylecop_static_readonly_fields_group -- PascalCase required
#      See https://github.com/DotNetAnalyzers/StyleCopAnalyzers/blob/master/documentation/SA1311.md
dotnet_naming_symbols.stylecop_static_readonly_fields_group.applicable_accessibilities = internal, private_protected, private, public, protected, protected_internal
dotnet_naming_symbols.stylecop_static_readonly_fields_group.required_modifiers         = static, readonly
dotnet_naming_symbols.stylecop_static_readonly_fields_group.applicable_kinds           = field
dotnet_naming_rule.stylecop_static_readonly_fields_must_be_pascal_case_rule.symbols  = stylecop_static_readonly_fields_group
dotnet_naming_rule.stylecop_static_readonly_fields_must_be_pascal_case_rule.style    = pascal_case_style
dotnet_naming_rule.stylecop_static_readonly_fields_must_be_pascal_case_rule.severity = warning

# SC3. stylecop_fields_must_be_private -- explicitly DISALLOW public, internal, and protected fields
#      See https://github.com/DotNetAnalyzers/StyleCopAnalyzers/blob/master/documentation/SA1401.md
dotnet_naming_symbols.stylecop_fields_must_be_private_group.applicable_accessibilities = internal, private_protected, public, protected, protected_internal
dotnet_naming_symbols.stylecop_fields_must_be_private_group.applicable_kinds           = field
dotnet_naming_rule.stylecop_fields_must_be_private_rule.symbols  = stylecop_fields_must_be_private_group
dotnet_naming_rule.stylecop_fields_must_be_private_rule.style    = disallowed_style
dotnet_naming_rule.stylecop_fields_must_be_private_rule.severity = error

# SC4. stylecop_private_fields_group -- camelCase required
#      See https://github.com/DotNetAnalyzers/StyleCopAnalyzers/blob/master/documentation/SA1306.md
dotnet_naming_symbols.stylecop_private_fields_group.applicable_accessibilities = private
dotnet_naming_symbols.stylecop_private_fields_group.applicable_kinds           = field
dotnet_naming_rule.stylecop_private_fields_rule.symbols  = stylecop_private_fields_group
dotnet_naming_rule.stylecop_private_fields_rule.style    = camel_case_style
dotnet_naming_rule.stylecop_private_fields_rule.severity = warning

# SC5. local variables ... any naming convention applied?
dotnet_naming_symbols.stylecop_local_field_group.applicable_accessibilities = local
dotnet_naming_symbols.stylecop_local_field_group.applicable_kinds           = field
dotnet_naming_rule.stylecop_local_field_rule.symbols  = stylecop_local_field_group
dotnet_naming_rule.stylecop_local_field_rule.style    = camel_case_style
dotnet_naming_rule.stylecop_local_field_rule.severity = silent

# XXH. This rule should never fire.  If it does, it indicates a new type of field
#      has become possible (as occured with C# 7.2's `private protected`)
dotnet_naming_symbols.sanity_check_uncovered_field_case_group.applicable_accessibilities = *
dotnet_naming_symbols.sanity_check_uncovered_field_case_group.applicable_kinds           = field
dotnet_naming_rule.sanity_check_uncovered_field_case_rule.symbols  = sanity_check_uncovered_field_case_group
dotnet_naming_rule.sanity_check_uncovered_field_case_rule.style    = missing_rule_for_field_style
dotnet_naming_rule.sanity_check_uncovered_field_case_rule.severity = warning

# END NAMING CONVENTIONS FOR FIELDS ==================================
######################################################################

# All of the following must be PascalCase:
# * Namespaces
#      See https://docs.microsoft.com/en-us/dotnet/standard/design-guidelines/names-of-namespaces
#      See https://github.com/DotNetAnalyzers/StyleCopAnalyzers/blob/master/documentation/SA1300.md
# * Class names and Enums
#      Note: not sure if `enum members` are covered by `enum`?
#      See https://docs.microsoft.com/en-us/dotnet/standard/design-guidelines/names-of-classes-structs-and-interfaces
#      See https://github.com/DotNetAnalyzers/StyleCopAnalyzers/blob/master/documentation/SA1300.md
# * Delegates
#      (Suffix cannot be enforced by .editorconfig rules, as it may be either EventHandler or Callback)
#      See https://docs.microsoft.com/en-us/dotnet/standard/design-guidelines/names-of-classes-structs-and-interfaces#names-of-common-types
# * Methods, Properties, Events, Constructors
#      See https://docs.microsoft.com/en-us/dotnet/standard/design-guidelines/names-of-type-members
# 
dotnet_naming_symbols.element_group.applicable_kinds = namespace, class, enum, struct, delegate, event, method, property
dotnet_naming_rule.element_rule.symbols  = element_group
dotnet_naming_rule.element_rule.style    = pascal_case_style
dotnet_naming_rule.element_rule.severity = warning

# Interfaces use PascalCase and are prefixed with uppercase 'i'
#      See https://docs.microsoft.com/en-us/dotnet/standard/design-guidelines/names-of-classes-structs-and-interfaces
dotnet_naming_symbols.interface_group.applicable_kinds = interface
dotnet_naming_rule.interface_rule.symbols  = interface_group
dotnet_naming_rule.interface_rule.style    = prefix_interface_with_i_style
dotnet_naming_rule.interface_rule.severity = warning

# Generics Type Parameters use PascalCase and are prefixed with uppercase 't'
#      See https://docs.microsoft.com/en-us/dotnet/standard/design-guidelines/names-of-classes-structs-and-interfaces
dotnet_naming_symbols.type_parameter_group.applicable_kinds = type_parameter
dotnet_naming_rule.type_parameter_rule.symbols  = type_parameter_group
dotnet_naming_rule.type_parameter_rule.style    = prefix_type_parameters_with_t_style
dotnet_naming_rule.type_parameter_rule.severity = warning

# Function parameters use camelCase
#      See https://docs.microsoft.com/en-us/dotnet/standard/design-guidelines/naming-parameters
dotnet_naming_symbols.parameters_group.applicable_kinds = parameter
dotnet_naming_rule.parameters_rule.symbols  = parameters_group
dotnet_naming_rule.parameters_rule.style    = camel_case_style
dotnet_naming_rule.parameters_rule.severity = warning